Subject: Re: libbpf-devel rpm uapi headers

From: Jiri Olsa <[email-masked]>
Date: Wed, 2 Oct 2019 22:08:18 +0200

On Wed, Oct 02, 2019 at 11:43:17AM -0700, Alexei Starovoitov wrote:
> On Wed, Oct 02, 2019 at 07:43:31PM +0200, Jiri Olsa wrote:
> > hi,
> > we'd like to have bcc linked with libbpf instead of the
> > github submodule, initial change is discussed in here:
> >   https://github.com/iovisor/bcc/pull/2535
> > 
> > In order to do that, we need to have access to uapi headers
> > compatible with libbpf rpm, bcc is attaching and using them
> > during compilation.
> > 
> > I added them in the fedora spec below (not submitted yet),
> > so libbpf would carry those headers.
> > 
> > Thoughts? thanks,
> 
> I think it may break a bunch of people who rely on bcc being a single library.

there's still libbpf.a available so it's still possible

> What is the main motiviation to use libbpf as a shared library in libbcc?

Besides that it's better to share common source of libbpf code,
it also prevents issues when having application that links to
libbpf and libbcc, where you could end up conflicting functions
and segfaults if those 2 libbpf libs are not on the same version.

quote from the github pull request ;-)

bpftrace links to libbcc, which carries libbcc_bpf and if I link
bpftrace with libbpf, the dynamic loader might get consused and
I get crash if those 2 libbpf libs (bcc x bpftrace) are not the
same version

> 
> I think we can have both options. libbpf as git submodule and as shared.
> In practice git submodule is so much simpler to use and a lot less headaches.

that's what the change to bcc suggests.. the build detects libbpf-devel
and if available links with it.. Yonghong suggested we also need uapi
headers so we don't rely on standard kernel headers

jirka